Package com.pixelmed.dicom

## Class AttributeTagAttribute

- java.lang.Object
- - com.pixelmed.dicom.Attribute
  - - com.pixelmed.dicom.AttributeTagAttribute

-     public class AttributeTagAttribute
      extends Attribute

  A concrete class specializing `Attribute` for Attribute Tag (AT) attributes.

  Though an instance of this class may be created using its constructors, there is also a factory class, `AttributeFactory`.

  See Also:
    `Attribute`, `AttributeFactory`, `AttributeList`

- - ### Field Summary

    - ### Fields inherited from class com.pixelmed.dicom.Attribute

      `valueLength, valueMultiplicity`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AttributeTagAttribute​(AttributeTag t)` | Construct an (empty) attribute.
    `AttributeTagAttribute​(AttributeTag t, long vl, DicomInputStream i)` | Read an attribute from an input stream.
    `AttributeTagAttribute​(AttributeTag t, java.lang.Long vl, DicomInputStream i)` | Read an attribute from an input stream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addValue​(int g, int e)` |
    `void` | `addValue​(AttributeTag t)` |
    `void` | `addValue​(java.lang.String s)` | Add a(nother) `String` value after any existing values of this attribute.
    `AttributeTag[]` | `getAttributeTagValues()` |
    `java.lang.String[]` | `getStringValues​(java.text.NumberFormat format)` | Get the values of this attribute as strings.
    `byte[]` | `getVR()` | Get the value representation of this attribute (AT).
    `void` | `removeValues()` | Remove any existing values, making the attribute empty (zero length).
    `java.lang.String` | `toString​(DicomDictionary dictionary)` | Dump the contents of the attribute as a human-readable string.
    `void` | `write​(DicomOutputStream o)` | Write the entire attribute (including values) to the output stream.

    - ### Methods inherited from class com.pixelmed.dicom.Attribute

      `addValue, addValue, addValue, addValue, addValue, addValue, getByteValues, getByteValues, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrDefault, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrEmptyString, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDelimitedStringValuesOrNull, getDoubleValues, getDoubleValues, getDoubleValues, getElement, getFloatValues, getFloatValues, getFloatValues, getGroup, getIntegerValues, getIntegerValues, getIntegerValues, getLengthOfBaseOfEncodedAttribute, getLengthOfEncodedValue, getLengthOfEntireEncodedAttribute, getLongValues, getLongValues, getLongValues, getOriginalStringValues, getPaddedVL, getShortValues, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleDoubleValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleFloatValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleIntegerValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleLongValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrDefault, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrEmptyString, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getSingleStringValueOrNull, getStringValues, getStringValues, getStringValues, getStringValues, getStringValues, getTag, getVL, getVM, getVRAsString, isValid, repairValues, setValue, setValue, setValue, setValue, setValue, setValue, setValue, setValues, setValues, setValues, setValues, setValues, setValues, setValues, toString, writeBase`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AttributeTagAttribute

          public AttributeTagAttribute​(AttributeTag t)

      Construct an (empty) attribute.

      Parameters:
        `t` - the tag of the attribute

    - #### AttributeTagAttribute

          public AttributeTagAttribute​(AttributeTag t,
                                       long vl,
                                       DicomInputStream i)
                                throws java.io.IOException,
                                       DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `DicomException` - if error in DICOM encoding

    - #### AttributeTagAttribute

          public AttributeTagAttribute​(AttributeTag t,
                                       java.lang.Long vl,
                                       DicomInputStream i)
                                throws java.io.IOException,
                                       DicomException

      Read an attribute from an input stream.

      Parameters:
        `t` - the tag of the attribute
        `vl` - the value length of the attribute
        `i` - the input stream
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `DicomException` - if error in DICOM encoding

  - ### Method Detail

    - #### write

          public void write​(DicomOutputStream o)
                     throws DicomException,
                            java.io.IOException

      Description copied from class: `Attribute`

      Write the entire attribute (including values) to the output stream.

      Specified by:
        `write` in class `Attribute`
      Parameters:
        `o` - the output stream
      Throws:
        `DicomException` - if error in DICOM encoding
        `java.io.IOException` - if an I/O error occurs

    - #### toString

          public java.lang.String toString​(DicomDictionary dictionary)

      Description copied from class: `Attribute`

      Dump the contents of the attribute as a human-readable string.

      No new line is appended.

      The result is of the form:

           (0xgggg,0xeeee) Name VR=<XX> VL=<0xnnnn> <...>

      For example:

           (0x0018,0x0020) ScanningSequence VR=<CS> VL=<0x2> <GR>

      Overrides:
        `toString` in class `Attribute`
      Parameters:
        `dictionary` - the dictionary to use to look up the name
      Returns:
        a single `String` value

    - #### getStringValues

          public java.lang.String[] getStringValues​(java.text.NumberFormat format)
                                             throws DicomException

      Description copied from class: `Attribute`

      Get the values of this attribute as strings.

      The strings may have been cleaned up into a canonical form, such as to remove padding as well as numbers formatted.

      Overrides:
        `getStringValues` in class `Attribute`
      Parameters:
        `format` - the format to use for each numerical or decimal value
      Returns:
        the values as an array of `String`
      Throws:
        `DicomException` - thrown if values are not available (such as not supported for this concrete attribute class)

    - #### getAttributeTagValues

          public AttributeTag[] getAttributeTagValues()
                                               throws DicomException

      Returns:
        the values
      Throws:
        `DicomException` - thrown if values are not available

    - #### addValue

          public void addValue​(int g,
                               int e)
                        throws DicomException

      Parameters:
        `g` - group number
        `e` - element number
      Throws:
        `DicomException` - never thrown

    - #### addValue

          public void addValue​(AttributeTag t)
                        throws DicomException

      Parameters:
        `t` - the tag
      Throws:
        `DicomException` - never thrown

    - #### addValue

          public void addValue​(java.lang.String s)
                        throws DicomException

      Description copied from class: `Attribute`
      Add a(nother) `String` value after any existing values of this attribute.
      Overrides:
        `addValue` in class `Attribute`
      Parameters:
        `s` - a String of the form returned by `toString()`, i.e., "(0xgggg,0xeeee)" where gggg and eeee are the zero-padded hexadecimal representations of the group and element respectively
      Throws:
        `DicomException` - if String is not a valid representation of a tag

    - #### removeValues

          public void removeValues()

      Description copied from class: `Attribute`

      Remove any existing values, making the attribute empty (zero length).

      Specified by:
        `removeValues` in class `Attribute`

    - #### getVR

          public byte[] getVR()

      Get the value representation of this attribute (AT).

      Overrides:
        `getVR` in class `Attribute`
      Returns:
        'A','T' in ASCII as a two byte array; see `ValueRepresentation`